public class DockUtils {
  public static Dock findRoot(Dock dock) {
    while (dock.getParentDock() != null) dock = dock.getParentDock();
    return dock;
  }

  public static void printModel(String indent, Dock dock) {
    System.out.println(
      indent + dock.getClass().getName() + "@" + dock.hashCode());
    for (Dockable d : dock.getDockables()) {
      if (d instanceof Dock) printModel(indent + "  ", (Dock) d);
      else System.out.println(
        indent + "  " + d.getClass().getName() + "@" + d.hashCode());
    }
  }

  public static void collapseSplitDocks(Dock dock) {
    if (dock instanceof SplitDock && dock.getDockableCount() == 1) {
      final Dock parent = ((SplitDock) dock).getParentDock();
      final Dockable child = dock.getDockables()[0];
      parent.replaceDockable((SplitDock) dock, child);
      
      if (child instanceof Dock) collapseSplitDocks((Dock) child);
    }
    else {
      for (Dockable d : dock.getDockables()) {
        if (d instanceof Dock) collapseSplitDocks((Dock) d);
      }
    }
  }

  public static void collapseTabDocks(Dock dock) {
    if (dock instanceof TabDock && dock.getDockableCount() == 0) {
      final Dock parent = ((TabDock) dock).getParentDock();
      parent.removeDockable((TabDock) dock);
    }
    else {
      for (Dockable d : dock.getDockables()) {
        if (d instanceof Dock) collapseTabDocks((Dock) d);
      }
    }
  }
}
