import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

public class Test {
  public static void main(String[] args) throws Exception {
    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        buildUI();
      }
    });
  }

  public static void buildUI() {
    final RootDock root = new RootDock();
    root.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));

    final SplitDock split1 = new SplitDock();
    final SplitDock split2 = new SplitDock();

    final TabDock left_top = new TabDock();
    final TabDock left_bottom = new TabDock();
    final TabDock right = new TabDock();

    root.addDockable(split1, null);
    split1.addDockable(split2, SplitDock.LEFT);
    split1.addDockable(right, SplitDock.RIGHT);
    split2.addDockable(left_top, SplitDock.TOP);
    split2.addDockable(left_bottom, SplitDock.BOTTOM);

    final ImageIcon icon = new ImageIcon(Test.class.getResource("dock.jpg"));

    final String loremIpsum = "Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.";

    final JTextArea textArea1 = new JTextArea(loremIpsum);
    textArea1.setLineWrap(true);
    textArea1.setWrapStyleWord(true);
    textArea1.setDragEnabled(false);
    textArea1.setTransferHandler(null);

    final JTextArea textArea2 = new JTextArea(loremIpsum + "\n\n" + loremIpsum + "\n\n" + loremIpsum + "\n\n" + loremIpsum);
    textArea2.setLineWrap(true);
    textArea2.setWrapStyleWord(true);
    textArea2.setDragEnabled(false);
    textArea2.setTransferHandler(null);

    final ImageIcon map = new ImageIcon(Test.class.getResource("cc.png"));
    final JScrollPane sp = new JScrollPane(new JLabel(map));
    sp.setPreferredSize(new Dimension(400,400));

    final Dockable foo = new DockableComponent(new JLabel(icon));
    final Dockable bar = new DockableComponent(new JScrollPane(textArea1));
    final Dockable baz = new DockableComponent(sp);
    final Dockable fro = new DockableComponent(new JScrollPane(textArea2));
/*
    final Dockable foo = new Dockable("Foo", new JLabel(icon));
    final Dockable bar = new Dockable("Bar", new JScrollPane(textArea1));
    final Dockable baz = new Dockable("Baz", sp);
    final Dockable fro = new Dockable("Frobnicate", new JScrollPane(textArea2));
*/

    left_bottom.addDockable(foo);
    left_top.addDockable(bar);
    right.addDockable(baz);
    right.addDockable(fro);

//    DockUtils.printModel("", root);
//    System.out.println("");

/*
    final JMenuBar mb = new JMenuBar();
    final JMenu viewMenu = new JMenu("View");
    mb.add(viewMenu);

// FIXME: make tabs reappear
    final JCheckBoxMenuItem fooItem = new JCheckBoxMenuItem("Foo");
    final JCheckBoxMenuItem barItem = new JCheckBoxMenuItem("Bar");
    final JCheckBoxMenuItem bazItem = new JCheckBoxMenuItem("Baz");
    final JCheckBoxMenuItem froItem = new JCheckBoxMenuItem("Frobnicate");

    fooItem.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (!fooItem.getState()) {
          foo.getParentDock().removeDockable(foo); 
        }
      }
    });

    viewMenu.add(fooItem);
    viewMenu.add(barItem);
    viewMenu.add(bazItem);
    viewMenu.add(froItem);
*/

    final JFrame frame = new JFrame("Test");
    frame.add(root);
//    frame.setJMenuBar(mb);
    frame.setResizable(true);
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setPreferredSize(new Dimension(800, 600));

    frame.setGlassPane(new DragGlassPane());

    frame.pack();
    frame.setVisible(true);
  }
}
