import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;

public class TransferableDockable implements Transferable {
  public static final DataFlavor FLAVOR =
    new DataFlavor(DataFlavor.javaJVMLocalObjectMimeType, "Dockable");

  private final Dockable dockable;

  public TransferableDockable(Dockable dockable) {
    this.dockable = dockable;
  }

  public Object getTransferData(DataFlavor flavor)
                                          throws UnsupportedFlavorException {
    if (FLAVOR.equals(flavor)) return dockable;
    else throw new UnsupportedFlavorException(flavor);
  }

  public DataFlavor[] getTransferDataFlavors() {
    return new DataFlavor[] { FLAVOR };
  }

  public boolean isDataFlavorSupported(DataFlavor flavor) {
    return FLAVOR.equals(flavor);
  }
}
